<!DOCTYPE html>
<html>

<head>
  <title>task 38.20 </title>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <!-- Import style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.3/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.13.3/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.3/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
  <!-- khUng lọc role  -->
  <div class="container-fluid jumbotron">
    <div class="row">
      <div class="col-sm-2 text-right">
        <h3 class="text-center" for="">Role</h3>
      </div>
      <div class="col-sm-2 input-group">
        <select id="select-role" class="form-control form-select" name="">
        </select>
      </div>
      <div class="col-sm-2">
        <button id="btn-loc-role" class="btn btn-success form-control">Lọc Dữ Liệu</button>
      </div>
    </div>
  </div>
  <!-- bảng hiển thị thông tin người dùng  -->
  <div class="container-fluid">
    <table id="table-user" class="table table-striped table-hover table-bordered">
      <thead>
        <tr>
          <th>STT</th>
          <th>User Name</th>
          <th>First name</th>
          <th>Last Name</th>
          <th>Email</th>
          <th>Age</th>
          <th>Role</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody></tbody>
    </table>

  </div>

</body>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // khai báo biến toàn cục cho số thứ tự;
  var gStt = 0;
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
    {
      id: 2,
      username: "quannv",
      firstname: "Ngo Van",
      lastname: "Quan",
      age: 18,
      email: "quan@gmail.com",
      roleId: 5
    },
    {
      id: 3,
      username: "longdh",
      firstname: "Do Hoang",
      lastname: "Long",
      age: 19,
      email: "long@gmail.com",
      roleId: 8
    },
    {
      id: 4,
      username: "hiendt",
      firstname: "Do Thi",
      lastname: "Hien",
      age: 29,
      email: "hien@gmail.com",
      roleId: 11
    },
    {
      id: 6,
      username: "lanht",
      firstname: "Ho Thi",
      lastname: "Lan",
      age: 27,
      email: "lan@gmail.com",
      roleId: 13
    }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
    {
      roleId: 5,
      roleName: "Admin"
    },
    {
      roleId: 8,
      roleName: "Manager"
    },
    {
      roleId: 11,
      roleName: "Teacher"
    },
    {
      roleId: 13,
      roleName: "Staff"
    }
  ];

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function () {
    onPageLoading();
    $("#btn-loc-role").click(onLocRoleClick);
    $("#table-user").on("click", ".i-dice-user", onDiceHistoryClick);
    $("#table-user").on("click", ".i-voucher-user", onVoucherClick);
  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onLocRoleClick() {
    "use strict"
    console.log("đã ấn nút lọc role");
    // b1 thu thâpj dữ liệu  thu thập roleID
    var vRoleID = $("#select-role").val();
    console.log(vRoleID);
    // b2 validate data kiểm tra  Role ID 
    if (!isNaN(vRoleID)) {
      // so sánh vRoleId với role trong gObjectUser 
      // trả về là 1 mảng chưa roleID
      var filtered = gUserObjects.filter(function (str) {
        var vArr = str.roleId;
        return vArr == vRoleID;
      });
      // b3 hiển thị font end   load Lại bảng 
      getInsertRowTable(filtered);
    }
  }
  // khai báo sự kiện nút dice history
  function onDiceHistoryClick() {
    console.log("đã ấn nút dice history"); // username, firstname, lastname
    var vRowClick = $(this).closest("tr"); // xác định hàng của nút ấn trên table  nut ấn 
    var vTable = $("#table-user").DataTable();   // tạo biến đến dataTable 
    var vDataRow = vTable.row(vRowClick).data();  // tìm hàng này trên data table trên data table 
    // lấy data trền hàng đó ,
    console.log(vDataRow);
    var vUrl = "Task38.30DiceHistory.html"
      + "?username=" + vDataRow.username
      + "&firstname=" + vDataRow.firstname
      + "&lastname=" + vDataRow.lastname;
    window.location.href = vUrl;   // chuyển đến trang "Task38.30DiceHistory.html"   và truyền tham số 
  }
  // khai báo sự kiện nút onVoucherClick()
  function onVoucherClick() {
    console.log("đã ấn nút voucher");
    var vRowClick = $(this).closest("tr"); // xác định hàng của nút ấn trên table  nut ấn 
    var vTable = $("#table-user").DataTable();   // tạo biến đến dataTable 
    var vDataRow = vTable.row(vRowClick).data();  // tìm hàng này trên data table trên data table 
    var vUrl = "38.40VoucherHistory.html"
    + "?username=" + vDataRow.username
      + "&firstname=" + vDataRow.firstname
      + "&lastname=" + vDataRow.lastname;

    window.location.href = vUrl;  // chuyển đến trang 38.40VoucherHistory.html   và truyền tham số 
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function onPageLoading() {
    loadDataTable();   // khởi tạo table  nhưng không đổ dữ liệu 
    loadDataSelectRole(); // đổ dữ liệu vào table đã khởi tạo 
  }
  // hàm thêm từng dòng dữ liệu vào
  function loadDataTable() {
    // khai báo mảng chứa giá trị các cột 
    const ARRAY_NAME_COL = ["stt", "username", "firstname", "lastname", "email", "age", "roleId", "action"];
    // định nghĩa số thứ tự cho các cột 
    const COL_STT = 0;
    const COL_USER_NAME = 1;
    const COL_FIRST_NAME = 2;
    const COL_LAST_NAME = 3;
    const COL_EMAIL = 4;
    const COL_AGE = 5;
    const COL_ROLE_ID = 6;
    const COL_ACTION = 7;

    // cấu hình lại table
    // Khi load (tải) trang thì hiển thị toàn bộ dữ liệu user (Tách thành 04 bước) => 1 bước 
    $("#table-user").DataTable({
      paging: true,   // phân trang
      lengthChange: true,  // ố bản ghi / mỗi trang
      searching: true,  // tìm kiếm 
      ordering: false,    //sắp xếp
      columns: [
        { data: ARRAY_NAME_COL[COL_STT] },
        { data: ARRAY_NAME_COL[COL_USER_NAME] },
        { data: ARRAY_NAME_COL[COL_FIRST_NAME] },
        { data: ARRAY_NAME_COL[COL_LAST_NAME] },
        { data: ARRAY_NAME_COL[COL_EMAIL] },
        { data: ARRAY_NAME_COL[COL_AGE] },
        { data: ARRAY_NAME_COL[COL_ROLE_ID] },
        { data: ARRAY_NAME_COL[COL_ACTION] },
      ],
      columnDefs: [
        {
          targets: COL_STT,   // cột STT
          render: function () {
            gStt++;
            return gStt;
          },
          className: "text-center text-primary",
        },
        {
          targets: 3, // cột age
          className: "text-right"
        },
        {
          targets: COL_ROLE_ID, // cột role
          render: renderRoleObject,
        },
        {
          targets: 7,
          defaultContent: `<i style="cursor: -webkit-grab; cursor: grab;" class="fa-solid fa-dice i-dice-user mr-2" aria-hidden="true" data-toggle="tooltip" data-placement="top" title="dice history" ></i>
                          <i  style="cursor: -webkit-grab; cursor: grab;" class="fa-solid fa-gift i-voucher-user" aria-hidden="true" data-toggle="tooltip" data-placement="top" title="voucher"></i>
          `,
        },
      ],
    });
    getInsertRowTable(gUserObjects);
  }
  // thêm dữ liệu lên bảng 
  function getInsertRowTable(paramRes) {
    var vTable = $("#table-user").DataTable();
    vTable.clear();// xóa trắng tbody trước khi load dữ liệu  
    vTable.rows.add(paramRes);  // thêm data vào đây 
    vTable.draw();      // render dữ liệu ra bảng 
    gStt = 0;  // làm mới lại biến toàn cục,
    // $('#example').tooltip(options)
  }
  // render cột role từ number sang string là các chức vụ
  function renderRoleObject(paramThis) {
    //gRoleObjects
    var vRoleName = "";
    var vDieuKien = false;
    var vVongLap = 0;
    while (!vDieuKien || vVongLap < gRoleObjects.length) {
      if (paramThis == gRoleObjects[vVongLap].roleId) {
        vRoleName = gRoleObjects[vVongLap].roleName;
        return vRoleName;
      }
      vVongLap++;
      vDieuKien = true;
    }
  }
  // đổ dữ liệu vào ô seclect 
  function loadDataSelectRole() {
    for (var i = 0; i < gRoleObjects.length; i++) {
      var vSelectRow = $("<option>"); // tạo 1 option 
      vSelectRow.val(gRoleObjects[i].roleId);
      vSelectRow.html(gRoleObjects[i].roleName);
      $("#select-role").append(vSelectRow);
    }

  }

  // ..................................[[DICE HISTORY ]]..........................
  // lấy gias trị của hàng trên data table
  function takeDataInRow() {

  }

</script>

</html>